"use strict";
cc._RF.push(module, '1039dFpwwNIcLe8XtUDlnzI', 'Item');
// scripts/component/Item.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Constant_1 = require("../Constant");
var EventManager_1 = require("../manager/EventManager");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Item = /** @class */ (function (_super) {
    __extends(Item, _super);
    function Item() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.label = null;
        _this._gfx = null;
        _this._itemData = null;
        _this._move = null;
        _this._vec = cc.v2();
        _this._isTitle = false;
        return _this;
    }
    Item.prototype.onLoad = function () {
        this._gfx = this.node.getComponent(cc.Graphics);
        EventManager_1.default.getInstance().on(Constant_1.EventType.ITEM_TOUCH, this.onItemTouch, this);
        EventManager_1.default.getInstance().on(Constant_1.EventType.UI_TOUCH, this.onUITouch, this);
    };
    Item.prototype.onDestroy = function () {
        EventManager_1.default.getInstance().off(Constant_1.EventType.ITEM_TOUCH, this);
        EventManager_1.default.getInstance().off(Constant_1.EventType.UI_TOUCH, this);
    };
    Item.prototype.onTouchStart = function () {
        this._move = 0;
        this._gfx.fillColor = cc.Color.GREEN;
        this._gfx.rect(-this.node.width / 2, -this.node.height / 2, this.node.width, this.node.height);
        this._gfx.fill();
    };
    Item.prototype.onTouchMove = function (event) {
        var delta = event.getDelta();
        this._move += delta.mag();
    };
    Item.prototype.onTouchEnd = function () {
        this._gfx.clear();
        if (this._move <= 20) {
            EventManager_1.default.getInstance().emit(Constant_1.EventType.ITEM_TOUCH, this._vec);
        }
    };
    Item.prototype.onTouchCancel = function () {
        EventManager_1.default.getInstance().emit(Constant_1.EventType.UI_TOUCH);
    };
    Item.prototype.onItemTouch = function (vec) {
        if (!this._isTitle && this._vec.equals(vec)) {
            this._gfx.fillColor = cc.Color.YELLOW;
            this._gfx.rect(-this.node.width / 2, -this.node.height / 2, this.node.width, this.node.height);
            this._gfx.fill();
        }
        else if (this._isTitle && this._vec.x == vec.x) {
            this._gfx.fillColor = cc.Color.YELLOW;
            this._gfx.rect(-this.node.width / 2, -this.node.height / 2, this.node.width, this.node.height);
            this._gfx.fill();
        }
        else {
            this._gfx.clear();
        }
    };
    Item.prototype.onUITouch = function () {
        this._gfx.clear();
    };
    Item.prototype.initItem = function (data, vec, isTitle) {
        this._itemData = data;
        this._vec = vec;
        this._isTitle = isTitle;
        if (typeof data == "string") {
            this.label.string = decodeURI(encodeURI(data));
        }
        else {
            this.label.string = decodeURI(encodeURI(JSON.stringify(data)));
        }
        if (!this._isTitle) {
            this.node.on(cc.Node.EventType.TOUCH_START, this.onTouchStart, this);
            this.node.on(cc.Node.EventType.TOUCH_MOVE, this.onTouchMove, this);
            this.node.on(cc.Node.EventType.TOUCH_END, this.onTouchEnd, this);
            this.node.on(cc.Node.EventType.TOUCH_CANCEL, this.onTouchCancel, this);
        }
    };
    __decorate([
        property(cc.Label)
    ], Item.prototype, "label", void 0);
    Item = __decorate([
        ccclass
    ], Item);
    return Item;
}(cc.Component));
exports.default = Item;

cc._RF.pop();