"use strict";
cc._RF.push(module, '756a6fFTVhAuI9M8Txxdj7Z', 'UIFile');
// scripts/ui/UIFile.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Constant_1 = require("../Constant");
var DataManager_1 = require("../manager/DataManager");
var EventManager_1 = require("../manager/EventManager");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var UIFile = /** @class */ (function (_super) {
    __extends(UIFile, _super);
    function UIFile() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ctrl = null;
        _this._file_name = "";
        return _this;
    }
    UIFile.prototype.start = function () {
        this.showFileControl(false);
        this.addInputListen();
        EventManager_1.default.getInstance().on(Constant_1.EventType.SHOW_FILE_DATA, this.onFileShow, this);
    };
    UIFile.prototype.onDestroy = function () {
        EventManager_1.default.getInstance().off(Constant_1.EventType.SHOW_FILE_DATA, this);
    };
    UIFile.prototype.onFileShow = function () {
        this.showFileControl(true);
    };
    UIFile.prototype.addInputListen = function () {
        var _this = this;
        this._input = document.createElement('input');
        this._input.type = 'file';
        this._input.onchange = function (e) {
            var files = e.target['files'];
            if (files.length == 0) {
                return;
            }
            _this._file_name = files[0].name;
            var reader = new FileReader();
            reader.onload = function (e) {
                var data = JSON.parse(reader.result.toString());
                DataManager_1.default.getInstance().setData(data);
                EventManager_1.default.getInstance().emit(Constant_1.EventType.SHOW_FILE_DATA);
            };
            reader.readAsText(files[0]);
        };
    };
    UIFile.prototype.showFileControl = function (isShow) {
        this.ctrl.active = isShow;
        this.ctrl.getChildByName("createRow").active = isShow && DataManager_1.default.getInstance().isArrayData();
    };
    // 点击打开按钮
    UIFile.prototype.onOpenClick = function () {
        if (this._file_name != "") {
            // TODO 弹出提示，当前正在编辑文件，是否放弃
        }
        this._input.click();
    };
    // 点击保存按钮
    UIFile.prototype.onSaveClick = function () {
        var data = ""; // TODO 解析数据
        var textFileAsBlob = new Blob([data], { type: 'text' });
        var downloadLink = document.createElement('a');
        downloadLink.download = this._file_name;
        downloadLink.innerHTML = 'Download File';
        if (window.webkitURL != null) {
            downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
        }
        else {
            downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
            downloadLink.onclick = function () {
                if (downloadLink)
                    document.body.removeChild(downloadLink);
            };
            downloadLink.style.display = 'none';
            document.body.appendChild(downloadLink);
        }
        downloadLink.click();
    };
    // 点击新建按钮
    UIFile.prototype.onCreateClick = function () {
        if (this._file_name != "") {
            // TODO 弹出提示，当前正在编辑文件，是否放弃
        }
        // TODO 打开新建窗口
    };
    __decorate([
        property({ type: cc.Node, displayName: '控制节点', tooltip: '文件操作节点，包含创建行列功能' })
    ], UIFile.prototype, "ctrl", void 0);
    UIFile = __decorate([
        ccclass
    ], UIFile);
    return UIFile;
}(cc.Component));
exports.default = UIFile;

cc._RF.pop();