"use strict";
cc._RF.push(module, '9add6KwZpVLX4JOAW18BspV', 'Cotent');
// scripts/component/Cotent.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Constant_1 = require("../Constant");
var DataManager_1 = require("../manager/DataManager");
var EventManager_1 = require("../manager/EventManager");
var Item_1 = require("./Item");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Content = /** @class */ (function (_super) {
    __extends(Content, _super);
    function Content() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.gfx = null;
        _this.inner = null;
        _this.isTitle = false;
        _this._pfb = null;
        return _this;
    }
    Content.prototype.onLoad = function () {
        this.node.on(cc.Node.EventType.TOUCH_MOVE, this.doMove, this);
        this.node.on(cc.Node.EventType.MOUSE_WHEEL, this.doMouseWheel, this);
        EventManager_1.default.getInstance().on(Constant_1.EventType.ON_TITLE_MOVE_X, this.onTitleMove, this);
        EventManager_1.default.getInstance().on(Constant_1.EventType.ON_DATA_MOVE_X, this.onDataMove, this);
    };
    Content.prototype.onDestroy = function () {
        EventManager_1.default.getInstance().off(Constant_1.EventType.ON_TITLE_MOVE_X, this);
        EventManager_1.default.getInstance().off(Constant_1.EventType.ON_DATA_MOVE_X, this);
    };
    Content.prototype.onTitleMove = function (x) {
        if (!this.isTitle) {
            this.node.x = x;
        }
    };
    Content.prototype.onDataMove = function (x) {
        if (this.isTitle) {
            this.node.x = x;
        }
    };
    Content.prototype.doMove = function (event) {
        var posX = event.getDeltaX();
        if (this.node.width > this.node.parent.width) {
            this.node.x = Constant_1.clamp(this.node.x + posX, -this.node.parent.width / 2 + this.node.parent.width - this.node.width, -this.node.parent.width / 2);
        }
        if (this.isTitle) {
            EventManager_1.default.getInstance().emit(Constant_1.EventType.ON_TITLE_MOVE_X, this.node.x);
        }
        else {
            EventManager_1.default.getInstance().emit(Constant_1.EventType.ON_DATA_MOVE_X, this.node.x);
            var posY = event.getDeltaY();
            if (this.node.height > this.node.parent.height) {
                this.node.y = Constant_1.clamp(this.node.y + posY, this.node.parent.height / 2, this.node.parent.height / 2 + this.node.height - this.node.parent.height);
            }
        }
    };
    Content.prototype.doMouseWheel = function (event) {
        if (!this.isTitle) {
            var deltaY = -event.getScrollY();
            if (this.node.height > this.node.parent.height) {
                this.node.y = Constant_1.clamp(this.node.y + deltaY, this.node.parent.height / 2, this.node.parent.height / 2 + this.node.height - this.node.parent.height);
            }
        }
    };
    Content.prototype.drawSheet = function (prefab) {
        this._pfb = prefab;
        var col = DataManager_1.default.getInstance().getDataCol();
        var row = this.isTitle ? 1 : DataManager_1.default.getInstance().getDataRow();
        this.node.width = Constant_1.SheetSize.width * col;
        this.node.x = -this.node.parent.width / 2;
        for (var i = 1; i <= col; ++i) {
            this.gfx.moveTo(i * Constant_1.SheetSize.width, 0);
            this.gfx.lineTo(i * Constant_1.SheetSize.width, -row * Constant_1.SheetSize.height);
        }
        this.node.height = Constant_1.SheetSize.height * row;
        this.node.y = this.node.parent.height / 2;
        for (var i = 1; i < row; ++i) {
            this.gfx.moveTo(0, -i * Constant_1.SheetSize.height);
            this.gfx.lineTo(this.node.width, -i * Constant_1.SheetSize.height);
        }
        this.gfx.moveTo(0, -this.node.height);
        this.gfx.lineTo(this.node.width, -this.node.height);
        this.gfx.stroke();
        this.showItems();
    };
    Content.prototype.displayRow = function (row) {
        var _this = this;
        if (row === void 0) { row = -1; }
        var data = DataManager_1.default.getInstance().getData();
        var keys = DataManager_1.default.getInstance().getSheetKey();
        keys.forEach(function (key, index) {
            var node = cc.instantiate(_this._pfb);
            node.parent = _this.inner;
            node.setPosition(cc.v2(Constant_1.SheetSize.width * (2 * index + 1) / 2, -Constant_1.SheetSize.height * (2 * Math.max(row, 0) + 1) / 2));
            node.getComponent(Item_1.default).initItem(_this.isTitle ? key : (row == -1 ? data[key] : data[row][key]), cc.v2(index, row), _this.isTitle);
        });
    };
    Content.prototype.showItems = function () {
        this.inner.removeAllChildren();
        if (this.isTitle || !DataManager_1.default.getInstance().isArrayData()) {
            this.displayRow();
        }
        else {
            var row = this.isTitle ? 1 : DataManager_1.default.getInstance().getDataRow();
            for (var i = 0; i < row; ++i) {
                this.displayRow(i);
            }
        }
    };
    __decorate([
        property(cc.Graphics)
    ], Content.prototype, "gfx", void 0);
    __decorate([
        property(cc.Node)
    ], Content.prototype, "inner", void 0);
    __decorate([
        property()
    ], Content.prototype, "isTitle", void 0);
    Content = __decorate([
        ccclass
    ], Content);
    return Content;
}(cc.Component));
exports.default = Content;

cc._RF.pop();