"use strict";
cc._RF.push(module, '9fa756+r2RPIoDvuHWM7nYQ', 'UIControl');
// scripts/ui/UIControl.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Constant_1 = require("../Constant");
var EventManager_1 = require("../manager/EventManager");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Page;
(function (Page) {
    Page[Page["File"] = 0] = "File";
    Page[Page["Item"] = 1] = "Item";
    Page[Page["Change"] = 2] = "Change";
})(Page || (Page = {}));
var UIControl = /** @class */ (function (_super) {
    __extends(UIControl, _super);
    function UIControl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.pages = [];
        return _this;
    }
    UIControl.prototype.onLoad = function () {
        this.node.on(cc.Node.EventType.TOUCH_END, function () {
            EventManager_1.default.getInstance().emit(Constant_1.EventType.UI_TOUCH);
        }, this);
        this.showPage(Page.File);
        EventManager_1.default.getInstance().on(Constant_1.EventType.ITEM_TOUCH, this.onItemTouch, this);
        EventManager_1.default.getInstance().on(Constant_1.EventType.ON_CHANGE_TOUCH, this.onChangeTouch, this);
        EventManager_1.default.getInstance().on(Constant_1.EventType.UI_TOUCH, this.onUITouch, this);
    };
    UIControl.prototype.onDestroy = function () {
        EventManager_1.default.getInstance().off(Constant_1.EventType.ITEM_TOUCH, this);
        EventManager_1.default.getInstance().off(Constant_1.EventType.ON_CHANGE_TOUCH, this);
        EventManager_1.default.getInstance().off(Constant_1.EventType.UI_TOUCH, this);
    };
    UIControl.prototype.onItemTouch = function () {
        this.showPage(Page.Item);
    };
    UIControl.prototype.onUITouch = function () {
        this.showPage(Page.File);
    };
    UIControl.prototype.onChangeTouch = function () {
        this.showPage(Page.Change);
    };
    UIControl.prototype.showPage = function (index) {
        this.pages.forEach(function (page, pidx) {
            page.active = index == pidx;
        });
    };
    __decorate([
        property({ type: [cc.Node], displayName: '页面数组', tooltip: 'UI包含的展示界面，默认起始0为文件操作页面' })
    ], UIControl.prototype, "pages", void 0);
    UIControl = __decorate([
        ccclass
    ], UIControl);
    return UIControl;
}(cc.Component));
exports.default = UIControl;

cc._RF.pop();