"use strict";
cc._RF.push(module, 'c924duzOpVG16rsR11sRHDm', 'UIChange');
// scripts/ui/UIChange.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Constant_1 = require("../Constant");
var DataManager_1 = require("../manager/DataManager");
var EventManager_1 = require("../manager/EventManager");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var ValueType;
(function (ValueType) {
    ValueType[ValueType["Null"] = -1] = "Null";
    ValueType[ValueType["Number"] = 0] = "Number";
    ValueType[ValueType["String"] = 1] = "String";
    ValueType[ValueType["Boolean"] = 2] = "Boolean";
    ValueType[ValueType["Object"] = 3] = "Object";
    ValueType[ValueType["Array"] = 4] = "Array";
})(ValueType || (ValueType = {}));
var UIChange = /** @class */ (function (_super) {
    __extends(UIChange, _super);
    function UIChange() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.edit_key = null;
        _this.types = [];
        _this.edit_value = null;
        _this.scroll = null;
        _this.lb_tips = null;
        _this._content = null;
        _this._pfb = null;
        _this._initType = ValueType.Null;
        _this._initKey = "";
        _this._nowType = ValueType.Null;
        _this._vec = null;
        return _this;
    }
    UIChange.prototype.onLoad = function () {
        var _this = this;
        this._content = this.scroll.children[0].children[0];
        this._pfb = this._content.children[0];
        this._pfb.parent = null;
        this.types.forEach(function (node, type) {
            node.on(cc.Node.EventType.TOUCH_END, function () {
                _this.chooseType(type);
            });
        });
        EventManager_1.default.getInstance().on(Constant_1.EventType.ON_CHANGE_TOUCH, this.onChangeTouch, this);
    };
    UIChange.prototype.onChangeTouch = function (vec) {
        this._vec = vec;
        var data = DataManager_1.default.getInstance().getData();
        var keys = DataManager_1.default.getInstance().getSheetKey();
        this.edit_key.string = keys[vec.x];
        this._initKey = keys[vec.x];
        this._initType = this.getType(data, keys, vec);
        this.chooseType(this._initType);
    };
    UIChange.prototype.chooseType = function (type) {
        this._nowType = type;
        this.types.forEach(function (node, index) {
            if (index == type) {
                node.color = cc.Color.GREEN;
                node.children[0].color = cc.Color.BLACK;
            }
            else {
                node.color = cc.Color.GRAY;
                node.children[0].color = cc.Color.WHITE;
            }
            ;
        });
        this.edit_value.node.active = type != ValueType.Null;
        this.scroll.active = type == ValueType.Object || type == ValueType.Array;
        this.showTips(type);
        this.refreshData();
    };
    UIChange.prototype.showTips = function (type) {
        var str = '';
        switch (type) {
            case ValueType.Null:
                str = "未知类型的值不可更改，请选择对应类型";
                break;
            case ValueType.Number:
                str = "修改类型为数字类型，所有数据对应字段将强制修改为数字类型，不能修改的值将设为0";
                break;
            case ValueType.String:
                str = "修改类型为字符，所有数据对应字段将强制修改为字符类型";
                break;
            case ValueType.Boolean:
                str = "修改类型为布尔，所有数据对应字段将强制先处理为数字再处理成布尔，0值为假，其余为真";
                break;
            case ValueType.Object:
                str = "修改类型为对象，其余值为空对象。值处填写数字为字段个数，列表中填写规则为：字段名:值";
                break;
            case ValueType.Array:
                str = "修改类型为数组，其余值为空数组。值处填写数组长度，列表中填写规则为：类型$$值  或者  类型$$字段名##值__字段名##值";
                break;
        }
        this.lb_tips.string = str;
    };
    UIChange.prototype.getType = function (data, keys, vec) {
        var type = ValueType.Null;
        var check;
        if (DataManager_1.default.getInstance().isArrayData()) {
            check = data[vec.y][keys[vec.x]];
        }
        else {
            check = data[keys[vec.x]];
        }
        switch (typeof check) {
            case "object":
                if (Array.isArray(check)) {
                    type = ValueType.Array;
                }
                else if (check) {
                    type = ValueType.Object;
                }
                break;
            case "string":
                type = ValueType.String;
                break;
            case "number":
                type = ValueType.Number;
                break;
            case "boolean":
                type = ValueType.Boolean;
                break;
            default:
                break;
        }
        return type;
    };
    UIChange.prototype.refreshData = function () {
        var data = DataManager_1.default.getInstance().getData();
        var keys = DataManager_1.default.getInstance().getSheetKey();
        var value;
        if (DataManager_1.default.getInstance().isArrayData()) {
            value = data[this._vec.y][keys[this._vec.x]];
        }
        else {
            value = data[keys[this._vec.x]];
        }
        if (this._nowType != this._initType) {
            switch (this._nowType) {
                case ValueType.Array:
                case ValueType.Object:
                    this.edit_value.string = "0";
                    this._content.removeAllChildren();
                    break;
                case ValueType.Number:
                    var num = parseFloat(value);
                    this.edit_value.string = isNaN(num) ? "0" : num.toString();
                    break;
                case ValueType.String:
                    this.edit_value.string = typeof value == "string" ? value : JSON.stringify(value);
                    break;
                case ValueType.Boolean:
                    var b = parseFloat(value);
                    this.edit_value.string = isNaN(b) ? "0" : (b == 0 ? "0" : "1");
                    break;
            }
        }
        else {
            switch (this._nowType) {
                case ValueType.Array:
                    this.showArrayData(value);
                    break;
                case ValueType.Object:
                    this.showObjectData(value);
                    break;
                case ValueType.Number:
                    var num = parseFloat(value);
                    this.edit_value.string = isNaN(num) ? "0" : num.toString();
                    break;
                case ValueType.String:
                    this.edit_value.string = typeof value == "string" ? value : JSON.stringify(value);
                    break;
                case ValueType.Boolean:
                    var b = parseFloat(value);
                    this.edit_value.string = isNaN(b) ? "0" : (b == 0 ? "0" : "1");
                    break;
            }
        }
    };
    UIChange.prototype.showArrayData = function (value) {
        var _this = this;
        this._content.removeAllChildren();
        this.scheduleOnce(function () {
            _this.edit_value.string = value.length.toString();
            for (var i = 0; i < value.length; ++i) {
                var node = cc.instantiate(_this._pfb);
                node.parent = _this._content;
                node.getComponent(cc.EditBox).string = _this.arrayItemToString(value[i]);
            }
        }, 0);
    };
    UIChange.prototype.showObjectData = function (value) {
        var _this = this;
        this._content.removeAllChildren();
        this.scheduleOnce(function () {
            var keys = Object.keys(value);
            _this.edit_value.string = keys.length.toString();
            for (var i = 0; i < value.length; ++i) {
                var node = cc.instantiate(_this._pfb);
                node.parent = _this._content;
                var type = _this.getTypeString(value[keys[i]]);
                node.getComponent(cc.EditBox).string = type + "##" + keys[i] + "##" + (type == "s" ? value[keys[i]] : JSON.stringify(value[keys[i]]));
            }
        }, 0);
    };
    UIChange.prototype.arrayItemToString = function (item) {
        var _this = this;
        switch (typeof item) {
            case 'string':
                return 's$$' + item;
            case 'number':
                return 'n$$' + item.toString();
            case 'boolean':
                return 'b$$' + (item ? "1" : "0");
            case 'object':
                if (Array.isArray(item)) {
                    return "a$$" + JSON.stringify(item);
                }
                else if (item) {
                    var str_1 = "o$$";
                    var keys = Object.keys(item);
                    keys.forEach(function (key) {
                        if (str_1 != "o$$") {
                            str_1 += '__';
                        }
                        var type = _this.getTypeString(item[key]);
                        if (type == 'a' || type == 'o') {
                            str_1 += type + "##" + key + "##" + JSON.stringify(item[key]);
                        }
                        else {
                            str_1 += type + "##" + key + "##" + item[key];
                        }
                    });
                    return str_1;
                }
                break;
        }
        return '';
    };
    UIChange.prototype.getTypeString = function (data) {
        switch (typeof data) {
            case 'string':
                return 's';
            case 'number':
                return 'n';
            case 'boolean':
                return 'b';
            case 'object':
                if (Array.isArray(data)) {
                    return "a";
                }
                else if (data) {
                    return "o";
                }
                break;
        }
        return '';
    };
    UIChange.prototype.onCancelClick = function () {
        EventManager_1.default.getInstance().emit(Constant_1.EventType.UI_TOUCH);
    };
    UIChange.prototype.onSaveClick = function () {
        if (this._nowType != this._initType) {
            // TODO 提示类型已修改，会改变所有对应的数据
        }
        else {
            var newKey = this.edit_key.string;
            if (newKey != this._initKey) {
                // 键名修改
                var result = DataManager_1.default.getInstance().changeSheetKey(this._initKey, newKey);
                if (!result)
                    return;
            }
            var data = void 0;
            switch (this._initType) {
                case ValueType.Array:
                    data = this.getArrayData();
                    break;
                case ValueType.Object:
                    data = this.getObjectData();
                    break;
                case ValueType.Number:
                    data = parseFloat(this.edit_value.string);
                    break;
                case ValueType.String:
                    data = this.edit_value.string;
                    break;
                case ValueType.Boolean:
                    data = parseInt(this.edit_value.string) != 0;
                    break;
            }
            DataManager_1.default.getInstance().changeData(newKey, data, this._vec.y);
        }
        EventManager_1.default.getInstance().emit(Constant_1.EventType.SHOW_FILE_DATA); // 刷新数据展示
        EventManager_1.default.getInstance().emit(Constant_1.EventType.UI_TOUCH); // 切换页面
    };
    UIChange.prototype.getArrayData = function () {
        var _this = this;
        var data = [];
        var items = this._content.children;
        items.forEach(function (item, index) {
            var edit = item.getComponent(cc.EditBox);
            var str = edit.string;
            var stype = str[0];
            var svalue = str.slice(3);
            switch (stype) {
                case 's':
                    data.push(svalue);
                    break;
                case 'n':
                    data.push(parseFloat(svalue));
                    break;
                case 'b':
                    data.push(parseInt(svalue) != 0);
                    break;
                case 'o':
                    var temp_1 = {};
                    var arr = svalue.split("__");
                    arr.forEach(function (s) {
                        var d = s.split("##");
                        temp_1[d[1]] = _this.parseData(d);
                    });
                    data.push(temp_1);
                    break;
                case 'a':
                    data.push(JSON.parse(svalue));
                    break;
            }
        });
        return data;
    };
    UIChange.prototype.getObjectData = function () {
        var data = {};
        var items = this._content.children;
        items.forEach(function (item, index) {
            var edit = item.getComponent(cc.EditBox);
            var arr = edit.string.split("##");
            var stype = arr[0];
            var skey = arr[1];
            var svalue = arr[2];
            switch (stype) {
                case 's':
                    data[skey] = arr[2];
                    break;
                default:
                    data[skey] = JSON.parse(arr[2]);
                    break;
            }
        });
        return data;
    };
    UIChange.prototype.parseData = function (data) {
        switch (data[0]) {
            case 'n':
                return parseFloat(data[2]);
            case 'b':
                return parseInt(data[2]) != 0;
            case 's':
                return data[2];
            case 'o':
            case 'a':
                return JSON.parse(data[2]);
        }
        return '';
    };
    __decorate([
        property({ type: cc.EditBox, displayName: '输入框 键', tooltip: "可修改键值" })
    ], UIChange.prototype, "edit_key", void 0);
    __decorate([
        property({ type: [cc.Node], displayName: '类型选项', tooltip: "类型单选框，-1未知 0数字 1字符 2布尔 3对象 4数组" })
    ], UIChange.prototype, "types", void 0);
    __decorate([
        property({ type: cc.EditBox, displayName: '输入框 值', tooltip: "\u53EF\u4FEE\u6539\u503C\n\n                                                                    1\u3001\u7C7B\u578B\u4E3A\u6570\u5B57\u65F6\uFF0C\u975E\u6570\u5B57\u7C7B\u578B\u5C06\u4FDD\u5B58\u4E3A0\n\n                                                                    2\u3001\u7C7B\u578B\u4E3A\u5B57\u7B26\u65F6\uFF0C\u6240\u6709\u503C\u5C06\u8F6C\u6210\u5B57\u7B26\u4E32\n\n                                                                    3\u3001\u7C7B\u578B\u4E3A\u5E03\u5C14\u65F6\uFF0C\u96640\u548C\u7A7A\u4E32\u5916\u6240\u6709\u503C\u4E3A\u771F\n\n                                                                    4\u3001\u7C7B\u578B\u4E3A\u5BF9\u8C61\u6216\u6570\u7EC4\u65F6\uFF0C\u6B64\u503C\u4E3A\u6570\u5B57\uFF0C\u8868\u793A\u5B57\u6BB5\u4E2A\u6570\u6216\u6570\u7EC4\u957F\u5EA6" })
    ], UIChange.prototype, "edit_value", void 0);
    __decorate([
        property({ type: cc.Node, displayName: '值列表', tooltip: '仅在类型为对象或数组时显示' })
    ], UIChange.prototype, "scroll", void 0);
    __decorate([
        property({ type: cc.Label, displayName: '提示文本', tooltip: '在类型为对象或数组时展示规则提示' })
    ], UIChange.prototype, "lb_tips", void 0);
    UIChange = __decorate([
        ccclass
    ], UIChange);
    return UIChange;
}(cc.Component));
exports.default = UIChange;

cc._RF.pop();