"use strict";
cc._RF.push(module, 'fefaaArofJHD4HSASGKleER', 'UIItem');
// scripts/ui/UIItem.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Constant_1 = require("../Constant");
var DataManager_1 = require("../manager/DataManager");
var EventManager_1 = require("../manager/EventManager");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var UIItem = /** @class */ (function (_super) {
    __extends(UIItem, _super);
    function UIItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.lb_key = null;
        _this.lb_type = null;
        _this.lb_value = null;
        _this.lb_describe = null;
        _this._vec = null;
        return _this;
    }
    UIItem.prototype.onLoad = function () {
        EventManager_1.default.getInstance().on(Constant_1.EventType.ITEM_TOUCH, this.displayData, this);
    };
    UIItem.prototype.onDestroy = function () {
        EventManager_1.default.getInstance().off(Constant_1.EventType.ITEM_TOUCH, this);
    };
    UIItem.prototype.displayData = function (vec) {
        var keys = DataManager_1.default.getInstance().getSheetKey();
        var data = DataManager_1.default.getInstance().getData();
        this.lb_key.string = "键名: " + keys[vec.x];
        var vt = this.getValueType(data, keys, vec);
        this.lb_type.string = "类型: " + vt[1];
        this.lb_value.string = "值:\n" + vt[0];
        this.lb_describe.string = ""; // 描述暂时置空
    };
    UIItem.prototype.getValueType = function (data, keys, vec) {
        this._vec = vec;
        var str, check;
        var value;
        if (DataManager_1.default.getInstance().isArrayData()) {
            check = data[vec.y][keys[vec.x]];
        }
        else {
            check = data[keys[vec.x]];
        }
        switch (typeof check) {
            case "object":
                if (Array.isArray(check)) {
                    str = "数组";
                }
                else if (!check) {
                    str = "未知";
                }
                else {
                    str = "对象";
                }
                value = JSON.stringify(check);
                break;
            case "string":
                str = "字符";
                value = check;
                break;
            case "number":
                str = "数字";
                value = check.toString();
                break;
            case "boolean":
                str = "布尔";
                value = check.toString();
                break;
            default:
                str = "未知";
                value = JSON.stringify(check);
                break;
        }
        return [value, str];
    };
    UIItem.prototype.onBtnClick = function () {
        EventManager_1.default.getInstance().emit(Constant_1.EventType.ON_CHANGE_TOUCH, this._vec);
    };
    __decorate([
        property({ type: cc.Label, displayName: '键', tooltip: '展示所选对象的键的字段或对应描述的文本' })
    ], UIItem.prototype, "lb_key", void 0);
    __decorate([
        property({ type: cc.Label, displayName: '类型', tooltip: '展示所选对象的类型的文本' })
    ], UIItem.prototype, "lb_type", void 0);
    __decorate([
        property({ type: cc.Label, displayName: '值', tooltip: '展示所选对象的值的文本' })
    ], UIItem.prototype, "lb_value", void 0);
    __decorate([
        property({ type: cc.Label, displayName: '描述', tooltip: '展示所选对象的描述的文本' })
    ], UIItem.prototype, "lb_describe", void 0);
    UIItem = __decorate([
        ccclass
    ], UIItem);
    return UIItem;
}(cc.Component));
exports.default = UIItem;

cc._RF.pop();